package sun.java2d.d3d;

import sun.java2d.loops.GraphicsPrimitive;
import sun.font.GlyphList;
import sun.java2d.pipe.BufferedContext;
import java.awt.Composite;
import sun.java2d.SunGraphics2D;
import sun.java2d.pipe.RenderQueue;
import sun.java2d.pipe.BufferedTextPipe;

class D3DTextRenderer extends BufferedTextPipe
{
    D3DTextRenderer(RenderQueue rq) {
        super(rq);
    }
    
    @Override
    protected native void drawGlyphList(int p0, boolean p1, boolean p2, boolean p3, int p4, float p5, float p6, long[] p7, float[] p8);
    
    @Override
    protected void validateContext(SunGraphics2D sg2d, Composite comp) {
        D3DSurfaceData d3DSurfaceData = (D3DSurfaceData)sg2d.surfaceData;
        BufferedContext.validateContext(d3DSurfaceData, d3DSurfaceData, sg2d.getCompClip(), comp, null, sg2d.paint, sg2d, 0);
    }
    
    D3DTextRenderer traceWrap() {
        return new D3DTextRenderer.Tracer(this);
    }
    
    private static class Tracer extends D3DTextRenderer
    {
        Tracer(D3DTextRenderer d3DTextRenderer) {
            super(d3DTextRenderer.rq);
        }
        
        @Override
        protected void drawGlyphList(SunGraphics2D sg2d, GlyphList gl) {
            GraphicsPrimitive.tracePrimitive("D3DDrawGlyphs");
            super.drawGlyphList(sg2d, gl);
        }
    }
}
